diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityBoatEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityBoatEntry.java
new file mode 100644
index 000000000..a9b502be5
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityBoatEntry.java
@@ -0,0 +1,55 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.entity;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
+import net.minecraft.core.block.entity.TileEntityFlag;
+import net.minecraft.core.entity.vehicle.EntityBoat;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.World;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class EntityBoatEntry extends EntityEntry<EntityBoat>{
+    @Override
+    public void onTick(EntityBoat entity) {
+
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntityBoat entity) {
+        GuiListenerButton flagButton = new GuiListenerButton(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.boat.button.flag", false));
+        flagButton.setActionListener(() -> {
+            boolean flag;
+            if (entity.tileEntityFlag == null){
+                entity.tileEntityFlag = new TileEntityFlag();
+                flag = true;
+            } else {
+                entity.tileEntityFlag = null;
+                flag = false;
+            }
+            flagButton.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.boat.button.flag", flag);
+        });
+        return new ArrayList<GuiButton>(){{add(flagButton);}};
+    }
+
+    @Override
+    public EntityBoat getEntityInstance(Minecraft mc, World world) {
+        EntityBoat boat = new EntityBoat(world);
+        boat.yRot = 270f;
+        boat.zd = 100; // Causes the flag to rotate when enabled
+        return boat;
+    }
+
+    @Override
+    public void onOpen() {
+
+    }
+
+    @Override
+    public void onClose() {
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityCreeperEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityCreeperEntry.java
new file mode 100644
index 000000000..2fe012e36
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityCreeperEntry.java
@@ -0,0 +1,49 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.entity;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
+import net.minecraft.core.entity.monster.EntityCreeper;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.World;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class EntityCreeperEntry extends EntityEntry<EntityCreeper>{
+    @Override
+    public void onTick(EntityCreeper entity) {
+
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntityCreeper creeper) {
+        List<GuiButton> buttonList = new ArrayList<>();
+        boolean isCharged = creeper.getPowered();
+        GuiListenerButton chargedToggle = new GuiListenerButton(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.creeper.button.charged", isCharged));
+        chargedToggle.setActionListener(() -> {
+            boolean isCharged1 = creeper.getPowered();
+            isCharged1 = !isCharged1;
+            creeper.getEntityData().set(17, (byte) (isCharged1 ? 1 : 0));
+            chargedToggle.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.creeper.button.charged", isCharged1);
+        });
+        buttonList.add(chargedToggle);
+        return buttonList;
+    }
+
+    @Override
+    public EntityCreeper getEntityInstance(Minecraft mc, World world) {
+        return new EntityCreeper(world);
+    }
+
+    @Override
+    public void onOpen() {
+
+    }
+
+    @Override
+    public void onClose() {
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntry.java
new file mode 100644
index 000000000..7cfbb1c7c
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntry.java
@@ -0,0 +1,19 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.entity;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.world.World;
+
+import java.util.List;
+
+public abstract class EntityEntry<T extends Entity>{
+    public static final EntityEntry<Entity> blankEntry = new BlankEntry();
+    public EntityEntry(){}
+    public abstract void onTick(T entity);
+    public abstract List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, T entity);
+    public abstract T getEntityInstance(Minecraft mc, World world);
+    public abstract void onOpen();
+    public abstract void onClose();
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFallingSandEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFallingSandEntry.java
new file mode 100644
index 000000000..1b7a020b0
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFallingSandEntry.java
@@ -0,0 +1,64 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.entity;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.modelviewer.GuiModelViewer;
+import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.entity.EntityFallingSand;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class EntityFallingSandEntry extends EntityEntry<EntityFallingSand>{
+    @Override
+    public void onTick(EntityFallingSand entity) {
+
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntityFallingSand sand) {
+        GuiTextCycle<Integer> blockIdCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, 0, 120, 20, sand.blockID) {
+            @Override
+            public Integer cycleElement(Integer current, int offset) {
+                return GuiModelViewer.cycleBlockId(current, offset);
+            }
+
+            @Override
+            public Integer getElementFromString(String s) {
+                try {
+                    int id = Integer.parseInt(s);
+                    if (Block.blocksList[id] != null) return id;
+                } catch (Exception ignored){}
+                return sand.blockID;
+            }
+
+            @Override
+            public String getNameFromElement(Integer element) {
+                return String.valueOf(element);
+            }
+        };
+        blockIdCycle.textField.setPrefaceText("ID: ");
+        blockIdCycle.textField.setPlaceholder("Block ID");
+        blockIdCycle.setOnValueChanged(() -> sand.blockID = blockIdCycle.getCurrentElement());
+        return new ArrayList<GuiButton>(){{add(blockIdCycle);}};
+    }
+
+    @Override
+    public EntityFallingSand getEntityInstance(Minecraft mc, World world) {
+        return new EntityFallingSand(world);
+    }
+
+    @Override
+    public void onOpen() {
+
+    }
+
+    @Override
+    public void onClose() {
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFireflyEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFireflyEntry.java
new file mode 100644
index 000000000..a0d1e6e57
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityFireflyEntry.java
@@ -0,0 +1,66 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.entity;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.modelviewer.elements.GuiListSelectorButton;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
+import net.minecraft.core.entity.animal.EntityFireflyCluster;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.World;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Random;
+
+public class EntityFireflyEntry extends EntityEntry<EntityFireflyCluster>{
+    @Override
+    public void onTick(EntityFireflyCluster fireflyCluster) {
+        Random random = fireflyCluster.world.rand;
+        double dy = (random.nextFloat() * 2F - 1F) * (fireflyCluster.bbHeight);
+        double dx = (random.nextFloat() * 2F - 1F) * (fireflyCluster.bbWidth);
+        double dz = (random.nextFloat() * 2F - 1F) * (fireflyCluster.bbWidth);
+
+        if (random.nextInt(Math.max(1, 10 - fireflyCluster.getFireflyCount())) == 0) {
+            fireflyCluster.world.spawnParticle(fireflyCluster.getColor().getParticleName(), fireflyCluster.x + dx, fireflyCluster.y + dy, fireflyCluster.z + dz, fireflyCluster.xd, fireflyCluster.yd, fireflyCluster.zd, 99999D);
+        }
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntityFireflyCluster fireflyCluster) {
+        List<GuiButton> buttonList = new ArrayList<>();
+        GuiListenerSlider slider = new GuiListenerSlider(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.fireflycluster.slider.size", 0), 0f);
+        slider.setOnValueChanged(() -> {
+            fireflyCluster.setClusterSize((int) (slider.sliderValue * (fireflyCluster.maxClusterSize)));
+            slider.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.fireflycluster.slider.size", fireflyCluster.getClusterSize());
+        });
+
+        GuiListSelectorButton<EntityFireflyCluster.FireflyColor> button = new GuiListSelectorButton<EntityFireflyCluster.FireflyColor>(-1, - 120, slider.yPosition + 21, 120, 20, I18n.getInstance().translateKey("model.category.entity.fireflycluster.button.cycle"), EntityFireflyCluster.FireflyColor.fireFlyColors.values(), EntityFireflyCluster.FireflyColor.GREEN) {
+            @Override
+            public String getNameFromElement(EntityFireflyCluster.FireflyColor element) {
+                return element.getParticleName();
+            }
+        };
+        button.setActionListener(() -> fireflyCluster.setColor(button.getCurrentElement()));
+        buttonList.add(slider);
+        buttonList.add(button);
+        return buttonList;
+    }
+
+    @Override
+    public EntityFireflyCluster getEntityInstance(Minecraft mc, World world) {
+        EntityFireflyCluster cluster = new EntityFireflyCluster(world);
+        cluster.setClusterSize(0);
+        return cluster;
+    }
+
+    @Override
+    public void onOpen() {
+
+    }
+
+    @Override
+    public void onClose() {
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityItemEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityItemEntry.java
new file mode 100644
index 000000000..aefb08c79
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityItemEntry.java
@@ -0,0 +1,105 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.entity;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.modelviewer.GuiModelViewer;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
+import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class EntityItemEntry extends EntityEntry<EntityItem>{
+    @Override
+    public void onTick(EntityItem entityItem) {
+        entityItem.age++;
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntityItem entityItem) {
+        List<GuiButton> buttonList = new ArrayList<>();
+        entityItem.item = Block.stone.getDefaultStack();
+        GuiTextCycle<Integer> itemIdCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, 0, 120, 20, 1) {
+            @Override
+            public Integer cycleElement(Integer current, int offset) {
+                return GuiModelViewer.cycleItemId(current, offset);
+            }
+
+            @Override
+            public Integer getElementFromString(String s) {
+                try {
+                    int id = Integer.parseInt(s);
+                    return MathHelper.clamp(id, 0, Item.itemsList.length);
+                } catch (Exception ignored){}
+                return entityItem.item.itemID;
+            }
+
+            @Override
+            public String getNameFromElement(Integer element) {
+                return String.valueOf(element);
+            }
+        };
+        itemIdCycle.textField.setPrefaceText("ID: ");
+        itemIdCycle.textField.setPlaceholder("Item ID");
+
+        GuiTextCycle<Integer> metaCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, itemIdCycle.yPosition + 21, 120, 20, 0) {
+            @Override
+            public Integer cycleElement(Integer current, int offset) {
+                return (current + offset) & 0x3FFF;
+            }
+
+            @Override
+            public Integer getElementFromString(String s) {
+                try {
+                    int id = Integer.parseInt(s);
+                    return MathHelper.clamp(id, 0, 0x3FFF);
+                } catch (Exception ignored){}
+                return entityItem.item.getMetadata();
+            }
+
+            @Override
+            public String getNameFromElement(Integer element) {
+                return String.valueOf(element);
+            }
+        };
+        metaCycle.textField.setPrefaceText("Meta: ");
+        metaCycle.textField.setPlaceholder("Meta");
+        GuiListenerSlider sizeSlider = new GuiListenerSlider(-1, - 120, metaCycle.yPosition + 21,120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.item.slider.size", 1), 1/64f);
+
+        itemIdCycle.setOnValueChanged(() -> entityItem.item = new ItemStack(itemIdCycle.getCurrentElement(), (int) (sizeSlider.sliderValue * 64), metaCycle.getCurrentElement()));
+        metaCycle.setOnValueChanged(() -> entityItem.item = new ItemStack(itemIdCycle.getCurrentElement(), (int) (sizeSlider.sliderValue * 64), metaCycle.getCurrentElement()));
+
+        sizeSlider.setOnValueChanged(() -> {
+            entityItem.item.stackSize = (int) (sizeSlider.sliderValue * 64);
+            sizeSlider.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.item.slider.size", entityItem.item.stackSize);
+        });
+
+        buttonList.add(itemIdCycle);
+        buttonList.add(metaCycle);
+        buttonList.add(sizeSlider);
+        return buttonList;
+    }
+
+    @Override
+    public EntityItem getEntityInstance(Minecraft mc, World world) {
+        return new EntityItem(world);
+    }
+
+    @Override
+    public void onOpen() {
+
+    }
+
+    @Override
+    public void onClose() {
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityMinecartEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityMinecartEntry.java
new file mode 100644
index 000000000..55ad456a2
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityMinecartEntry.java
@@ -0,0 +1,44 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.entity;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
+import net.minecraft.core.entity.vehicle.EntityMinecart;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.World;
+import org.lwjgl.input.Keyboard;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class EntityMinecartEntry extends EntityEntry<EntityMinecart>{
+    @Override
+    public void onTick(EntityMinecart entity) {
+
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntityMinecart minecart) {
+        GuiListenerButton button = new GuiListenerButton(-1, - 120, 0, 120, 20, I18n.getInstance().translateKey("model.category.entity.minecart.button.cycle"));
+        button.setActionListener(() -> minecart.minecartType = (minecart.minecartType + 3 + (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) ? -1 : 1)) % 3);
+        return new ArrayList<GuiButton>(){{add(button);}};
+    }
+
+    @Override
+    public EntityMinecart getEntityInstance(Minecraft mc, World world) {
+        EntityMinecart minecart = new EntityMinecart(world);
+        minecart.yRot = 270;
+        return minecart;
+    }
+
+    @Override
+    public void onOpen() {
+
+    }
+
+    @Override
+    public void onClose() {
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityPaintingEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityPaintingEntry.java
new file mode 100644
index 000000000..df97616ca
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityPaintingEntry.java
@@ -0,0 +1,46 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.entity;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
+import net.minecraft.core.entity.EntityPainting;
+import net.minecraft.core.enums.ArtType;
+import net.minecraft.core.world.World;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class EntityPaintingEntry extends EntityEntry<EntityPainting>{
+    @Override
+    public void onTick(EntityPainting entity) {
+
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntityPainting painting) {
+        GuiListenerSlider slider = new GuiListenerSlider(-1, - 120, 0, 120, 20, painting.art.key, 0f);
+        slider.setOnValueChanged(() -> {
+            painting.art = ArtType.values.get((int) (slider.sliderValue * (ArtType.values.size() - 1)));
+            slider.displayString = painting.art.key;
+        });
+        return new ArrayList<GuiButton>(){{add(slider);}};
+    }
+
+    @Override
+    public EntityPainting getEntityInstance(Minecraft mc, World world) {
+        EntityPainting painting = new EntityPainting(world);
+        painting.setDirection(2);
+        return painting;
+    }
+
+    @Override
+    public void onOpen() {
+
+    }
+
+    @Override
+    public void onClose() {
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySheepEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySheepEntry.java
new file mode 100644
index 000000000..2005f4784
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySheepEntry.java
@@ -0,0 +1,52 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.entity;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
+import net.minecraft.core.entity.animal.EntitySheep;
+import net.minecraft.core.item.ItemDye;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.World;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class EntitySheepEntry extends EntityEntry<EntitySheep>{
+    @Override
+    public void onTick(EntitySheep entity) {
+
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntitySheep sheep) {
+        List<GuiButton> buttonList = new ArrayList<>();
+        GuiListenerSlider slider = new GuiListenerSlider(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.sheep.slider.color", "White"), 0f);
+        slider.setOnValueChanged(() -> {
+            sheep.setFleeceColor((int) (slider.sliderValue * 15));
+            String color = ItemDye.dyeColors[15 - sheep.getFleeceColor()];
+            String c = String.valueOf(color.charAt(0));
+            color = c.toUpperCase() + color.substring(1);
+            slider.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.sheep.slider.color", color);
+        });
+        buttonList.add(slider);
+        return buttonList;
+    }
+
+    @Override
+    public EntitySheep getEntityInstance(Minecraft mc, World world) {
+        EntitySheep sheep = new EntitySheep(world);
+        sheep.setFleeceColor(0);
+        return sheep;
+    }
+
+    @Override
+    public void onOpen() {
+
+    }
+
+    @Override
+    public void onClose() {
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySlimeEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySlimeEntry.java
new file mode 100644
index 000000000..2bbd32a5e
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySlimeEntry.java
@@ -0,0 +1,46 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.entity;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
+import net.minecraft.core.entity.monster.EntitySlime;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.World;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class EntitySlimeEntry extends EntityEntry<EntitySlime>{
+    @Override
+    public void onTick(EntitySlime entity) {
+
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntitySlime entity) {
+        List<GuiButton> buttonList = new ArrayList<>();
+        GuiListenerSlider slider = new GuiListenerSlider(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.slime.slider.size", 1), 0f);
+        slider.setOnValueChanged(() -> {
+            entity.setSlimeSize((int) (slider.sliderValue * 4) + 1);
+            slider.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.slime.slider.size", entity.getSlimeSize());
+        });
+        buttonList.add(slider);
+        return buttonList;
+    }
+
+    @Override
+    public EntitySlime getEntityInstance(Minecraft mc, World world) {
+        return new EntitySlime(world);
+    }
+
+    @Override
+    public void onOpen() {
+
+    }
+
+    @Override
+    public void onClose() {
+
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityTNTEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityTNTEntry.java
new file mode 100644
index 000000000..abe344c0c
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityTNTEntry.java
@@ -0,0 +1,45 @@
+package net.minecraft.client.gui.modelviewer.categories.entries.entity;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
+import net.minecraft.core.entity.EntityTNT;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.World;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class EntityTNTEntry extends EntityEntry<EntityTNT>{
+    @Override
+    public void onTick(EntityTNT entity) {
+
+    }
+
+    @Override
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntityTNT tnt) {
+        tnt.fuse = 80;
+        GuiListenerSlider slider = new GuiListenerSlider(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.tnt.slider.fuse", 80), 1f);
+        slider.setOnValueChanged(() -> {
+            tnt.fuse = (int) (slider.sliderValue * 80);
+            slider.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.tnt.slider.fuse", tnt.fuse);
+        });
+        return new ArrayList<GuiButton>(){{add(slider);}};
+    }
+
+    @Override
+    public EntityTNT getEntityInstance(Minecraft mc, World world) {
+        return new EntityTNT(world);
+    }
+
+    @Override
+    public void onOpen() {
+
+    }
+
+    @Override
+    public void onClose() {
+
+    }
+}
